import 'package:interceptable/src/interceptor/field_interceptor.dart';
import 'package:meta/meta.dart';
import 'package:renderable/renderable.dart';

class InterceptableFieldElement extends FieldElement {
  List<FieldInterceptor> fieldInterceptors = [];

  InterceptableFieldElement({
    @required String name,
    bool isStatic,
    bool isConst,
    bool isFinal,
    bool isSynthetic,
    DartType type,
    Renderable value,
    PropertyAccessorElement getter,
    PropertyAccessorElement setter,
  }) : super(
          name: name,
          isStatic: isStatic,
          isConst: isConst,
          isFinal: isFinal,
          isSynthetic: isSynthetic,
          type: type,
          value: value,
          getter: getter,
          setter: setter,
        );

  @override
  String render() {
    if (fieldInterceptors.isEmpty) {
      return '';
    }

    fieldInterceptors.forEach((e) => e.apply(this));

    return super.render();
  }
}
