import 'package:interceptable/interceptable.dart';
import 'package:interceptable/src/element/interceptable_field_element.dart';
import 'package:interceptable/src/interceptor/function_body_interceptor.dart';
import 'package:renderable/renderable.dart';

/// force field to use field instead of accessors
class AccessorInterceptor extends FieldInterceptor {
  FunctionBodyInterceptor getterBodyInterceptor;
  FunctionBodyInterceptor setterBodyInterceptor;

  AccessorInterceptor({
    this.getterBodyInterceptor,
    this.setterBodyInterceptor,
  });

  void apply(InterceptableFieldElement field) {
    field.isSynthetic = true;

    if (getterBodyInterceptor != null) {
      getterBodyInterceptor.apply(field.getter.body);
    }

    if (setterBodyInterceptor != null) {
      setterBodyInterceptor.apply(field.setter.body);
    }
  }
}
