//import 'package:renderable/renderable.dart';

import 'package:interceptable/src/misc/interceptable_function_body.dart';
import 'package:renderable/renderable.dart';

class FunctionBodyInterceptor {
  List<Statement> before;
  List<Statement> after;
  List<Statement> extraStatements;

  FunctionBodyInterceptor({
    this.before,
    this.after,
    this.extraStatements,
  }) {
    before ??= [];
    after ??= [];
    extraStatements ??= [];
  }

  void apply(InterceptableFunctionBody body) {
    body.before.addAll(Iterable.castFrom(before));
    body.after.addAll(Iterable.castFrom(after));
    body.statements.addAll(Iterable.castFrom(extraStatements));
  }
}
