import 'package:analyzer/dart/element/element.dart' as az;
import 'package:interceptable/interceptable.dart';
import 'package:renderable/renderable.dart';

class InterceptableManager {
  static Map<int, List<ImportElement>> importDict = {};
  static Map<int, List<ClassElement>> classDict = {};

  static ClassElement create(az.ClassElement element, String filePath) {
    int libId = element.library.id;

    /// parse imports
    List<ImportElement> imports = InterceptableElementConverter(element.library.id)
        .parseImports(element.library.imports)
        .where((e) => e != null)
        .toList()
          ..add(ImportElement(path: filePath));

    importDict[libId] = imports;

    /// parse class
    classDict[libId] ??= [];
    ClassElement itClass = InterceptableElementConverter(element.library.id).parseClass(element);
    classDict[libId].add(itClass);

    /// parse class
    return itClass;
  }
}
