import 'package:renderable/renderable.dart';

class InterceptableFunctionBody extends FunctionBody {
  List<Statement> before;
  List<Statement> after;

  InterceptableFunctionBody({
    this.before,
    this.after,
    List<Statement> statements,
    ReturnStatement returnStatement,
  }) : super(
          statements: statements,
          returnStatement: returnStatement,
        ) {
    before ??= [];
    after ??= [];
  }

  @override
  String render() {
    return [
      this.before.join('\n'),
      this.statements.join('\n'),
      this.after.join('\n'),
      returnStatement ?? '',
    ].join('\n');
  }
}
