import 'package:renderable/renderable.dart';

abstract class ParameterUtil {
  static String generatePassingString(List<ParameterElement> parameters) {
    List<ParameterElement> requiredParameters = parameters.where((e) => e.isRequired).toList();
    List<ParameterElement> namedParameters = parameters.where((e) => e.isNamed).toList();
    List<ParameterElement> optionalPositionalParameters =
        parameters.where((e) => e.isOptionalPositional).toList();

    List<String> templateList = [];

    if (requiredParameters.isNotEmpty) {
      templateList.add(requiredParameters.map((e) => e.name).join(', '));
    }

    if (optionalPositionalParameters.isNotEmpty) {
      templateList.add('${optionalPositionalParameters.map((e) => e.name).join(', ')}');
    }

    if (namedParameters.isNotEmpty) {
      templateList.add('${namedParameters.map((e) => "${e.name}: ${e.name}").join(', ')}');
    }

    return templateList.join(', ');
  }
}
